/*
 * SimpleInputMethodPlugin.java - Simple Input Method Plug-in
 * :tabSize=8:indentSize=8:noTabs=false:
 * :folding=explicit:collapseFolds=1:
 *
 * Copyright (C) 2005 Yusuke SHIROYAMA
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
import org.gjt.sp.jedit.*;
import org.gjt.sp.jedit.msg.*;
import org.gjt.sp.jedit.textarea.JEditTextArea;

public class SimpleInputMethodPlugin extends EBPlugin
{
	public static final String NAME = "simpleinputmethod";
	public static final String MENU = "simpleinputmethod.menu";
	public static final String PROPERTY_PREFIX = "plugin.SimpleInputMethodPlugin.";
	public static final String OPTION_PREFIX = "options.simpleinputmethod.";

	public void handleMessage(EBMessage msg) {
		if (msg instanceof EditPaneUpdate) {
			// EditPane is updated
			EditPaneUpdate  epu_mes = (EditPaneUpdate)msg;
			if (epu_mes.getWhat() == EditPaneUpdate.CREATED) {
				installInputMethod(epu_mes.getEditPane());
			}
			//System.err.println(msg);
		}
	}

	/* Install EditPane to TextArea */
	void installInputMethod(EditPane edpane) {
		if (edpane.getTextArea().getInputMethodRequests() == null) {
			SimpleInputMethodRequests  req = new SimpleInputMethodRequests(edpane);
			edpane.getTextArea().setInputMethodRequests(req);
			//System.err.println("IM Installed.");
		}
		else {
			//System.err.println("IM is already installed");
		}
	}

	public void start() {
		EditBus.addToBus(this);
		//System.err.println("AddtoBus");
	}

	public void stop() {
		EditBus.removeFromBus(this);
		//System.err.println("RemoveFromBus");
	}
}
